function trouver_index(table, id) {
	let i = -1;
	table.forEach((ligne, index) => {
		if (ligne.html.id === parseInt(id)) {
			i = index;
		}
	});
	return i;
}

function recupJson(d) {
	try {
		return JSON.parse(d);
	} catch (e) {
		console.log("erreur recupJson ", e);
		return false;
	}
}

function navigate(href, newTab) {
	let a = document.createElement("a");
	a.href = href;
	if (newTab) {
		a.setAttribute("target", "_blank");
	}
	a.click();
}

function ordonnerSelect(a, b) {
	// attention ! le test d'égalité en == et non pas === est voulu tel quel...
	if (
		(Number.isInteger(a) || parseInt(a) == a) &&
		(Number.isInteger(b) || parseInt(b) == b)
	) {
		return parseInt(a) - parseInt(b);
	} else {
		let x = toString(a).toLowerCase();
		let y = toString(b).toLowerCase();
		if (x < y) {
			return -1;
		}
		if (x > y) {
			return 1;
		}
		return 0;
	}
}

const orderBy = (arr, props, orders, champ) =>
	arr.sort((a, b) =>
		props.reduce((acc, prop, i) => {
			if (acc === 0) {
				let [p1, p2] =
					orders && orders[i] === "desc"
						? [b[champ][prop], a[champ][prop]]
						: [a[champ][prop], b[champ][prop]];
				// passe en lowercase les String
				p1 = typeof p1 === "string" ? p1.toLowerCase() : p1;
				p2 = typeof p2 === "string" ? p2.toLowerCase() : p2;

				// Gestion du format de date
				// transforme 03/11/2000 en 20001103
				let re = /^(\d{2})\/(\d{2})\/(\d{2,4})$/;

				if (typeof p1 !== "number") {
					let r1 = p1.match(re);
					if (Array.isArray(r1)) {
						p1 = r1[3] + r1[2] + r1[1];
					}

					let r2 = p2.match(re);
					if (Array.isArray(r2)) {
						p2 = r2[3] + r2[2] + r2[1];
					}
				}

				acc = p1 > p2 ? 1 : p1 < p2 ? -1 : 0;
			}
			return acc;
		}, 0)
	);

export { orderBy, ordonnerSelect, navigate, recupJson, trouver_index };
